/******************************************************************************
*
* project name:    Scorch
* file name:       Gui##.c
* initial date:    27.12.2004
* author:          mhubi@freesurf.ch
* description:     graphical user interface
*
*******************************************************************************
*
* Scorch -- another tank-game
* Copyright (C) 2004-2005  Martin Huber
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
******************************************************************************/

#include "main-h13.h"

//BOOL option, cursor, OptionsOpened;


/*DEFINE_INT_HANDLER(CURSORBLINK)
{
  counter++;
  
  if (counter > 18) {
  	cursor = !cursor;
  	counter = 0;
  	GrayDrawChar(CALC(23,63), CALC(62+(option*10),90+(option*10)), 17, A_XOR);
  	GrayDrawChar(CALC(136,176), CALC(62+(option*10),90+(option*10)), 18, A_XOR);
  }
}*/

void P_R_choose(void) {
	
	//char pl_numk[5] = "2",roundsk[5] = "1";
	int key = 0;
	char string[16];
	
	BOOL option = 0;
	//BOOL cursor = FALSE;
	//OptionsOpened = TRUE;
	
	//SetIntVec(AUTO_INT_5, CURSORBLINK);
	
	game->set[LAND] = 0;
	game->set[WIND] = 0;
	game->set[START] = 0;
	game->set[SPECIAL] = 0;
	game->set[WALLS] = 0;
	game->set[WEATHER] = 0;
	game->rounds_now = 1;
	game->rounds = 1;
	game->pl_num = 2;
	
	//FontSetSys(CALC(F_6x8,F_8x10));
  GrayDrawStrExt(CALC(32,47), CALC(60,86), (char*)"Player:", A_NORMAL | A_SHADOWED, CALC(F_6x8,F_8x10));
  GrayDrawStrExt(CALC(32,47), CALC(72,98), (char*)"Rounds:", A_NORMAL | A_SHADOWED, CALC(F_6x8,F_8x10));
  sprintf(string, " %d  (2-5)", game->pl_num);
  GrayDrawStrExt(CALC(80,111), CALC(60,86), string, A_NORMAL, CALC(F_6x8,F_8x10));
  sprintf(string, " %d (1-99)", game->rounds);
  GrayDrawStrExt(CALC(80,111), CALC(72,98), string, A_NORMAL, CALC(F_6x8,F_8x10));
  //GrayDrawStr(CALC(88,125), CALC(56,88), pl_numk, A_NORMAL);
  //GrayDrawStr(CALC(88,125), CALC(70,98), roundsk, A_NORMAL);
  
  GrayFastFillRect_R(LPLANE,DPLANE,CALC(0,0),CALC(86,112),CALC(159,239),CALC(99,127),COLOR_DARKGRAY);
	GrayClipSprite8_OR_R(CALC(2,2), CALC(89,116), 7, shield, shield, LPLANE, LPLANE);
	GrayClipSprite8_OR_R(CALC(150,230), CALC(89,116), 7, shield, shield, LPLANE, LPLANE);
  GrayDrawStrExt(CALC(23,20), CALC(90,116), (char*)"[ENTER]=START : [F1]=QUICKSTART", A_XOR | A_CENTERED, CALC(F_4x6,F_6x8));
  
  Wait();
  
  DrawDoubleCursor(option);
  
  do {
		
		while (!(key = KeyPressed()) && game->status != GAMELOADED) {
			pokeIO(0x600005, 0b10111);
		}
		
		if (key == K_RIGHT || key == K_RIGHT + K_2ND) {
			if (!option) {
				//game->pl_num = ((game->pl_num+1) % 11) + ((game->pl_num+1) / 11);
				game->pl_num++;
				if (game->pl_num > 5) {
					game->pl_num = 2;
				}
				sprintf(string, " %d", game->pl_num);
			}
			else {
				//game->rounds = ((game->rounds+1) % 11) + ((game->rounds+1) / 11);
				if (key == K_RIGHT) {
					game->rounds++;
				}
				else if (key == K_RIGHT + K_2ND) {
					game->rounds += 10;
				}
				if (game->rounds > 99) {
					game->rounds = 1;
				}
				sprintf(string, " %d", game->rounds);			
			}
			GrayDrawStrExt(CALC(80,111)-((strlen(string)/3)*CALC(6,8)), CALC(60+(option*12),86+(option*12)), string, A_REPLACE, CALC(F_6x8,F_8x10));
		}
		
		if (key == K_LEFT || key == K_LEFT + K_2ND) {
			if (!option) {
				//game->pl_num = game->pl_num-1 ? game->pl_num-1 : 5; 
				game->pl_num--;
				if (game->pl_num < 2) {
					game->pl_num = 5;
				}
				sprintf(string, " %d", game->pl_num);
			}
			else {
				//game->rounds = game->rounds-1 ? game->rounds-1 : 99;
				if (key == K_LEFT) {
					game->rounds--;
				}
				else if (key == K_LEFT + K_2ND) {
					game->rounds -= 10;
				}
				if (game->rounds < 1) {
					game->rounds = 99;
				}
				sprintf(string, " %d", game->rounds);			
			}
			GrayDrawStrExt(CALC(80,111)-((strlen(string)/3)*CALC(6,8)), CALC(60+(option*12),86+(option*12)), string, A_REPLACE, CALC(F_6x8,F_8x10));
		}
		
		
		if ((key == K_UP && option) || (key == K_DOWN && !option)) {							
			
			/*if (cursor) {
				while (counter)	continue;
			}*/
			DrawDoubleCursor(option);
			
			option = !option;
			
			DrawDoubleCursor(option);
			
		}
		
		Delay(AUTO_REPEAT);
		
	} while (key != K_ENTER && key != K_F1 && game->status != GAMELOADED);
	
	if (key == K_F1) {
		
		LoadOptions(TRUE);
		
		game->status = QUICKSTART;
		
	}
	
	//SetIntVec(AUTO_INT_5, DUMMY_HANDLER);
	
	//OptionsOpened = FALSE;
  
  /*key = 0;
  
  while (key != K_ENTER) {
  	
  	while (!(key = KeyPressed()) && game->status != GAMELOADED) {
  		pokeIO(0x600005, 0b10111);
  	}
  	
  	if (game->status == GAMELOADED) {
  		return;
  	}
  	else if (key == K_1) {
  		++game->pl_num;
  		if (game->pl_num > 5) {
  			game->pl_num = 2;
  		}
  		GrayDrawStr(CALC(88,125),CALC(62,90),(char*)"  ",A_SHADED);
  		sprintf(pl_numk,"%d",game->pl_num);
  		GrayDrawStr(CALC(88,125),CALC(62,90),pl_numk,A_NORMAL);
  		
  		Wait();
  		
  	}
  	else if (key == K_2 || key == K_2 + K_2ND) {
  		if (key == K_2) {
  			++game->rounds;
  		}
  		else if (key == K_2 + K_2ND) {
  			game->rounds += 10;
  		}
  		if (game->rounds > 99) {
  			game->rounds = 1;
  		}
  		GrayDrawStr(CALC(88,125), CALC(72,100),(char*)"  ",A_SHADED);
  		sprintf(roundsk,"%d",game->rounds);
  		GrayDrawStr(CALC(88,125), CALC(72,100),roundsk,A_NORMAL);
  		
  		Delay(AUTO_REPEAT);
  		
  	}
  	
  }*/
  
}

void PlayerSettings(void) {
	
	curfunc = PL_SETTINGS;
	
	//background of initialisation
	Init_background();
	
	//initialisize each player
	for (game->pl_active = 0; game->pl_active < game->pl_num; game->pl_active++) {
		Player_init(game->pl_active);
	}
	
	
}

void Player_init(unsigned int num) {
	
	unsigned int loop1;
	int choice = 0;
	char string[16];
	
	Rectangle();
	DialogStatusLine(0);
  sprintf(string,"PLAYER %d",num+1);
  GrayDrawStrExt(0,CALC(16,30), string, A_NORMAL | A_CENTERED | A_SHADOWED, F_8x10);
  
  GrayDrawStrExt2B(CALC(20,55),CALC(31,45),(char*)"Human",A_NORMAL,F_6x8,DPLANE,DPLANE);
  GrayDrawStrExt2B(CALC(20,55),CALC(43,57),(char*)"Computer",A_NORMAL,F_6x8,DPLANE,DPLANE);
  
  choice = MakeChoice(CALC(20,55), CALC(31,45), 12, 2, F_6x8, 1);
  
  /*while (key != K_1 && key != K_2) {
  	
  	while (!(key = KeyPressed())) {
  		pokeIO(0x600005, 0b10111);
  	}
  	
  }*/
  
  Rectangle();
  GrayDrawStrExt(0,CALC(16,30), string, A_NORMAL | A_CENTERED | A_SHADOWED, F_8x10);
  
  if (choice == 1) {
  	
  	player[num].type = 1;
  	//GrayDrawStrExt(CALC(20,55),CALC(40,55),(char*)"          ",A_SHADED,F_6x8);
  	//GrayDrawStrExt(CALC(20,55),CALC(53,67),(char*)"             ",A_SHADED,F_6x8);
  	
  	DialogStatusLine(1);
  	
  	Wait();
  	
  	Inputstr(player[num].name,8); 
  	
  	player[num].angle = 45;
  	player[num].angle_img = player[num].angle;
  	player[num].power = 1;
  	player[num].strength = 0; //dummy
  	player[num].target = 10; //dummy
  	
  }
  
  else if (choice == 2) {
  	
  	player[num].type = 2;
  	
  	DialogStatusLine(0);
  	
  	Wait();
  	
  	strcpy(player[num].name, compnames[num]);
  	
  	player[num].strength = 0;
  	
  	for (loop1 = 1; loop1 <= AISTRENGTH; loop1++) {
  		
  		//sprintf(string, "(%d) %s", loop1, aistrenght[loop1 - 1]);
  		
  		GrayDrawStrExt2B(CALC(20,55),CALC(22, 36) + loop1*7 , aistrenght[loop1-1],A_NORMAL,F_4x6,DPLANE,DPLANE);
			
		}
		
		/*while (key < K_1 || key > K_3) {
			
			key = KeyPressed();
			
			pokeIO(0x600005, 0b10111);
			
		}*/
		choice = MakeChoice(CALC(20,55), CALC(29,43), 7, AISTRENGTH, F_4x6, 1);
		
		player[num].strength = choice;
		
		/*if (player[num].strength == AISTRENGTH) {
			
			//do {
			player[num].strength = 1 + random(AISTRENGTH-1);
			//} while (player[num].strength == 0);
			
		}*/
  	
  	
  	player[num].angle = 0;
  	player[num].angle_img = player[num].angle;
  	/*#if defined(TESTING)
  	//player[num].power = 15 + random(50);
  	//player[num].attempts = 0;
  	//player[num].target = 1;
  	//ChooseEnnemi(num);
  	
  	#else
  	player[num].power = 1 + random(99);
  	#endif*/
  	//player[num].hit = 10;
  	//player[num].try = 0;
  	
  }
  
  player[num].victory = 0;
  #if defined(TESTING)
  player[num].credits = 5000;
  #else
  player[num].credits = 0;
  #endif
  player[num].cr_total = 0;
  
  for (loop1 = 1; loop1 <= MERCH; loop1++) {
		#if defined(TESTING)
		player[num].bomb[loop1] = 50;
		#else
		player[num].bomb[loop1] = 0;
		#endif
		
	}
	player[num].bomb[0]=1;
	player[num].bomb[1]=99;
	
	Tankchose(num);
	
	//Debugging(num);
	
}

void DrawSettings(void) {
	
	unsigned int loop1;
	
	Rectangle();
	GrayDrawStrExt(0, CALC(16,30), (char*)"GAMEOPTIONS", A_NORMAL | A_CENTERED | A_SHADOWED, F_8x10);
	FontSetSys(F_4x6);
	
	GrayDrawStr2B(CALC(15,50),CALC(31,45),"landscape:",A_NORMAL,DPLANE,DPLANE);
	//GrayDrawStr2B(CALC(70,115),CALC(31,45),landscape[game->set[LAND]],A_NORMAL,DPLANE,DPLANE);
	
	GrayDrawStr2B(CALC(15,50),CALC(39,53),"wind:",A_NORMAL,DPLANE,DPLANE);
	//GrayDrawStr2B(CALC(70,115),CALC(39,53),wind[game->set[WIND]],A_NORMAL,DPLANE,DPLANE);
	
	GrayDrawStr2B(CALC(15,50),CALC(47,61),"startvalues:",A_NORMAL,DPLANE,DPLANE);
	//GrayDrawStr2B(CALC(70,115),CALC(47,61),startvalues[game->set[START]],A_NORMAL,DPLANE,DPLANE);
	
	GrayDrawStr2B(CALC(15,50),CALC(55,69),"special events:",A_NORMAL,DPLANE,DPLANE);
	//GrayDrawStr2B(CALC(70,115),CALC(55,69),onoff[game->set[SPECIAL]],A_NORMAL,DPLANE,DPLANE);
	
	GrayDrawStr2B(CALC(15,50),CALC(63,77),"walls:",A_NORMAL,DPLANE,DPLANE);
	//GrayDrawStr2B(CALC(70,115),CALC(63,77),walls[game->set[WALLS]],A_NORMAL,DPLANE,DPLANE);
	
	GrayDrawStr2B(CALC(15,50),CALC(71,85),"weather:",A_NORMAL,DPLANE,DPLANE);
	//GrayDrawStr2B(CALC(70,115),CALC(71,85),weather[game->set[WEATHER]],A_NORMAL,DPLANE,DPLANE);
	
	for (loop1 = 0; loop1 < 6; loop1++) {
		//GrayDrawStr2B(CALC(15,50),CALC(31,45) + loop1*8,options_title[loop1],A_NORMAL,DPLANE,DPLANE);
		GrayDrawStr2B(CALC(70,115),CALC(31,45) + loop1*8,options[st_point[loop1] + game->set[loop1]],A_NORMAL,DPLANE,DPLANE);
	}
	
	DialogStatusLine(2);
	//GrayDrawStr2B(CALC(15,50),CALC(79,93),"(7)  load options",A_NORMAL,DPLANE,DPLANE);
	
	
}

void GameSettings(void) {
	
	int choice = 1;
	//int opt_limit[] = {6, 7, 4, 2, 3, 3};
	
	curfunc = GA_SETTINGS;
	
	DrawSettings();
	
	//DialogStatusLine(2);
	
	Wait();
	
	//while (key != K_ENTER) {
	do {
		
		//choice = 0;
		
		/*while (!(key = KeyPressed())) {
  		pokeIO(0x600005, 0b10111);
  	}*/
  	
  	choice = MakeChoice(CALC(15,50), CALC(31,45), 8, 6, F_4x6, choice);
		
		if (ABS(choice) <= 6) {
			game->set[ABS(choice)-1] += choice/(ABS(choice));
			if (game->set[ABS(choice)-1] > opt_limit[ABS(choice)-1]) {
				game->set[ABS(choice)-1] = 0;
			}
			else if (game->set[ABS(choice)-1] < 0) {
				game->set[ABS(choice)-1] = opt_limit[ABS(choice)-1];
			}
			//DrawSettings();
			
			choice = ABS(choice);
			
			GrayDrawStrExt2B(CALC(70,115),CALC(31,45) + (choice-1)*8,(char*)"                                ",A_REPLACE,F_4x6,DPLANE,DPLANE);
			GrayDrawStrExt2B(CALC(70,115),CALC(31,45) + (choice-1)*8,options[st_point[choice-1] + game->set[choice-1]],A_NORMAL,F_4x6,DPLANE,DPLANE);
			Delay(AUTO_REPEAT);
		}
		
		/*if (choice == 1) {
			Wait();
			++game->set[LAND];
			if (game->set[LAND] > 6) {
				game->set[LAND] = 0;
			}
			DrawSettings();
		}
		
		else if (choice == 2) {
			Wait();
			++game->set[WIND];
			if (game->set[WIND] > 7) {
				game->set[WIND] = 0;
			}
			DrawSettings();
		}
		
		else if (choice == 3) {
			Wait();
			++game->set[START];
			if (game->set[START] > 4) {
				game->set[START] = 0;
			}
			DrawSettings();
		}
		
		else if (choice == 4) {
			Wait();
			++game->set[SPECIAL];
			if (game->set[SPECIAL] > 2) {
				game->set[SPECIAL] = 0;
			}
			DrawSettings();
		}
		
		else if (choice == 5) {
			Wait();
			++game->set[WALLS];
			if (game->set[WALLS] > 3) {
				game->set[WALLS] = 0;
			}
			DrawSettings();
		}
		
		else if (choice == 6) {
			Wait();
			++game->set[WEATHER];
			if (game->set[WEATHER] > 2) {
				game->set[WEATHER] = 0;
			}
			DrawSettings();
		}*/
		
		else if (choice == K_F1) {
			Wait();
			LoadOptions(FALSE);
			DrawSettings();
			choice = 1;
			//DialogStatusLine(2);
		}
		
	} while (choice != -10);
	
	Wait();
	
	SaveOptions();
	
	for (choice = 0; choice < 6; choice++) {
		if (game->set[choice] == opt_limit[choice]) {
			game->set[choice] = random(opt_limit[choice]);
		}
	}
	
	/*if (game->set[LAND] == 6) {
		game->set[LAND] = random(6);
	}
	if (game->set[WIND] == 7) {
		game->set[WIND] = random(7);
	}
	if (game->set[START] == 4) {
		game->set[START] = random(4);
	}
	if (game->set[SPECIAL] == 2) {
		game->set[SPECIAL] = random(2);
	}
	if (game->set[WALLS] == 3) {
		game->set[WALLS] = random(3);
	}
	if (game->set[WEATHER] == 2) {
		game->set[WEATHER] = random(2);
	}*/
	
}

void Statistics(void) {
	
	unsigned int loop1, loop2;
	char string[30];
	unsigned int ranking[5];
	int max;
	
	SetIntVec(AUTO_INT_5, DUMMY_HANDLER);
	curfunc = STATISTICS;
			
	// find the player who won the round --> credits
	for (game->pl_check = 0; game->pl_check < game->pl_num; game->pl_check++) {
		
		
		if (player[game->pl_check].health > 0) {
			player[game->pl_check].victory ++;
			player[game->pl_check].cr_total += 2000;
			
			if (player[game->pl_check].credits <= 58000) {
				player[game->pl_check].credits += 2000;
			}
			
		}
		
	}
	
	Rectangle();
	/*if (game->rounds_now == game->rounds) {
		GrayDrawStrExt(0, CALC(16,30), (char*)"FINAL SCORE", A_NORMAL | A_CENTERED | A_SHADOWED, F_8x10);
	} 
	else {
		GrayDrawStrExt(0, CALC(16,30), (char*)"STATISTICS", A_NORMAL | A_CENTERED | A_SHADOWED, F_8x10);
	}*/
	
	GrayDrawStrExt(0, CALC(16,30), game->rounds_now == game->rounds ? (char*)"FINAL SCORE" : (char*)"STATISTICS", A_NORMAL | A_CENTERED | A_SHADOWED, F_8x10);
	
	FontSetSys(F_4x6);
	
	for (loop1 = 0; loop1 < game->pl_num; loop1++) {
		
		max = -1;
		
		for (loop2 = 0; loop2 < game->pl_num; loop2++) {
			
			if (CheckStat(loop2, loop1, ranking) == FALSE) {
				
				if (player[loop2].victory > max) {
					max = player[loop2].victory;
					ranking[loop1] = loop2;
				}
				else if (player[loop2].victory == max) {
					if (player[loop2].cr_total > player[ranking[loop1]].cr_total) {
						ranking[loop1] = loop2;
					}
				}
				
			}
			
		}
		
	}
	
	for (loop1 = 0; loop1 < game->pl_num; loop1++) {
		
		sprintf(string,"%d. %s", loop1+1, player[ranking[loop1]].name);
		GrayDrawStr(CALC(11,46),CALC(31,45) + loop1*7, string, A_NORMAL);
		sprintf(string,"%d",player[ranking[loop1]].victory);
		GrayDrawStr2B(CALC(75,110), CALC(31,45) + loop1*7,string,A_NORMAL, DPLANE,DPLANE);
		sprintf(string,"%li",player[ranking[loop1]].cr_total);
		GrayDrawStr2B(CALC(95,130), CALC(31,45) + loop1*7,string,A_NORMAL, DPLANE,DPLANE);
		GrayDrawStr2B(CALC(135,180), CALC(31,45) + loop1*7,(char*)"cr.",A_NORMAL,DPLANE,DPLANE);
		
		
	}
	
	sprintf(string, "after %d of %d round(s)", game->rounds_now, game->rounds);
	GrayDrawStrExt(0, CALC(70,84), string, A_NORMAL | A_CENTERED, F_6x8);
	
	DialogStatusLine(3);
	//Waitkey();
	
}

BOOL CheckStat(unsigned int num, unsigned int rank, unsigned int *ranking) {
	
	unsigned int loop1;
	
	if (rank == 0) {
		return FALSE;
	}
	
	for (loop1 = 0; loop1 <= rank; loop1++) {
		
		if (ranking[loop1] == num) {
			return TRUE;
		}
		
	}
	
	return FALSE;
	
}

void WeaponList(unsigned int num, unsigned int page, unsigned int mode) {
	
	int loop1;
	char string[24];
	
	Rectangle();
	
	if (mode == SHOP) {
		//sprintf(string,"SHOP Player %d",num+1);
		sprintf(string,"SHOP %s", player[num].name);
	}
	else {
		//sprintf(string,"INVENTORY Player %d",num + 1);
		sprintf(string,"INVENTORY %s", player[num].name);
	}
	GrayDrawStrExt(0, CALC(16,30), string, A_NORMAL | A_CENTERED | A_SHADOWED, F_8x10);
	FontSetSys(F_4x6);
	
	for (loop1 = 1; loop1 <= merchpage[page - 1]; loop1++) {
		
		GrayDrawStr2B(CALC(15,50),CALC(23,37) + loop1*8, bombname[loop1 + (page - 1)*MPP],A_NORMAL,DPLANE,DPLANE);
		sprintf(string,"%d",player[num].bomb[loop1 + (page - 1)*MPP]);
		GrayDrawStr2B(CALC(80,115),CALC(23,37) + loop1*8,string,A_NORMAL,DPLANE,DPLANE);
		if (mode == SHOP) {
			GrayDrawStr2B(CALC(100,135),CALC(23,37) + loop1*8,bombcost[loop1 - 1 + (page - 1)*MPP],A_NORMAL,DPLANE,DPLANE);
		}
	}
	
	WeaponStatusLine(num, page);
	
}

void WeaponStatusLine(unsigned int num, unsigned int page) {
	
	char string[16];
	
	GrayFastFillRect_R(LPLANE,DPLANE,CALC(6,41),CALC(84,95),CALC(154,199),CALC(90,101),COLOR_DARKGRAY);
	
	sprintf(string,"%u cr.",player[num].credits);
	GrayDrawStr2B(CALC(10,45), CALC(85,96),string,A_REVERSE,DPLANE,DPLANE);
	GrayDrawStr2B(CALC(53,96), CALC(85,96),(char*)"[ESC] = GO ON",A_REVERSE,DPLANE,DPLANE);
	sprintf(string,"\x15 page %d / %d \x16", page, PAGES);
	GrayDrawStr2B(CALC(105,150), CALC(85,96), string, A_REVERSE, DPLANE, DPLANE);
	
}

int WeaponCursor(int position, unsigned int page) {
	
	int key = 0;
	
	while (position > 0 && key != K_ENTER) {
		
		GrayDrawChar(CALC(9,44),CALC(23,37) + position*8, 18, A_NORMAL);
		
		while (!(key = KeyPressed())) {
  		pokeIO(0x600005, 0b10111);
  	}
		
		Delay(AUTO_REPEAT);
		
		GrayDrawStr(CALC(9,44),CALC(23,37) + position*8,(char*)"  ",A_SHADED);

		//if (key == K_ENTER) {
			//return position;
		//}
		if (key == K_ESC) {
			position = -1;
			//return position;
		}
		
		if (key == K_DOWN) {
			position++;
		}
		else if (key == K_UP) {
			position--;
		}
		else if (key == K_LEFT) {
			position = -10;
		}
		else if (key == K_RIGHT) {
			position = -20;
		}
		
		if (position > merchpage[page - 1]) {
			position = 1;
		}
		if (position == 0) {
			position = merchpage[page - 1];
		}
		//Wait();
		
	}
	
	if (position > 0) {	
		GrayDrawStr(CALC(9,44),CALC(23,37) + position*8,(char*)"  ",A_SHADED);
	}
	
	return position;
	
}

void Shop(unsigned int num) {
	
	int position;
	char string[16];
	unsigned int page = 1;
	
	curfunc = SHOP;
	
	WeaponList(num, page, SHOP);
	
	position = 1;
	
	while (position > 0) {
		
		position = WeaponCursor(position, page);
		
		if (position == -10) {
			position = 1;
			if (page != 1) {
				page--;
				WeaponList(num, page, SHOP);
			}
		}
		else if (position == -20) {
			position = 1;
			if (page != PAGES) {
				page++;
				WeaponList(num, page, SHOP);
			}
		}
		
		else if (position > 0 && player[num].bomb[MERCHPOS] < 90) {
			
			if (player[num].credits >= bomb_skill[MERCHPOS - 1][1]) {
				player[num].bomb[MERCHPOS] += bomb_skill[MERCHPOS - 1][0];
				player[num].credits -= bomb_skill[MERCHPOS - 1][1];
			}
			FontSetSys(F_4x6);
			GrayDrawStr2B(CALC(80,115), CALC(23,37) + position*8,"    ",A_SHADED,DPLANE,DPLANE);
			sprintf(string,"%d",player[num].bomb[MERCHPOS]);
			GrayDrawStr2B(CALC(80,115), CALC(23,37) + position*8,string,A_NORMAL,DPLANE,DPLANE);
			
			WeaponStatusLine(num, page);
			
		}
		
	}


}

void Init_background(void) {
	
	unsigned int loop1, loop2, loop3, x;
	
	GrayClearScreen();
  
  for (loop1 = 0; loop1 < CALC(7,10); loop1++) {
		for (loop2 = 0; loop2 <= 3; loop2++) {
			for (loop3 = 0; loop3 <= 2; loop3++) {
				x = loop2*3+loop1*24+loop3;
				if (x < CALC(160, 240)) {
					GrayFastDrawLine(x, 0, x, CALC(99,127), loop2);
				}
			}
		}
		for (loop2 = 0; loop2 <= 3; loop2++) {
			for (loop3 = 0; loop3 <= 2; loop3++) {
				x = loop2*3+loop1*24+12+loop3;
				if (x < CALC(160, 240)) {
					GrayFastDrawLine(x, 0, x, CALC(99,127), 3-loop2);
				}
			}
		}
	}
	
}


void Rectangle(void) {
	
	GrayFastFillRect_R(LPLANE,DPLANE,CALC(4,39),CALC(10,24),CALC(157,202),CALC(93,104),COLOR_WHITE);
	//GrayFastOutlineRect_R(LPLANE,DPLANE,CALC(6,41),CALC(11,25),CALC(156,201),CALC(92,103),COLOR_DARKGRAY);
	GrayFastDrawLine(CALC(6,41),CALC(92,103), CALC(156,201), CALC(92,103), COLOR_DARKGRAY);
	GrayFastDrawLine(CALC(156,201), CALC(12,26), CALC(156,201), CALC(92,103), COLOR_DARKGRAY);
	GrayFastOutlineRect_R(LPLANE,DPLANE,CALC(5,40),CALC(11,25),CALC(155,200),CALC(91,102),COLOR_BLACK);
	//GrayFastOutlineRect_R(LPLANE,DPLANE,CALC(6,41),CALC(12,26),CALC(154,199),CALC(90,101),COLOR_LIGHTGRAY);
	
	/*rayDrawRect(CALC(5,40),CALC(11,25),CALC(157,202),CALC(93,104),COLOR_DARKGRAY,RECT_FILLED);
	GrayDrawRect(CALC(4,39),CALC(10,24),CALC(156,201),CALC(92,103),COLOR_WHITE,RECT_FILLED);
	GrayDrawRect(CALC(5,40),CALC(11,25),CALC(155,200),CALC(91,102),COLOR_BLACK,RECT_EMPTY);*/
	
}

void Tankchose(unsigned int num) {
	
	unsigned int loop1 = 0;
	int key = 0;
	//char string[5];
	
	if (player[num].type == 1) {
		
		DialogStatusLine(0);
		
		for (loop1 = 1; loop1 <= TANKS; loop1++) {
			//sprintf(string,"%d",loop1);
			//GrayDrawStrExt2B(CALC(15,50) + loop1*16, CALC(60,74), string, A_NORMAL, F_6x8, DPLANE, DPLANE);
			Sprite16_OR_R(CALC(7,42) + loop1*16, CALC(50,64), 5, tanks[loop1-1], DPLANE);
		}
		
		GrayDrawChar(CALC(20,55), CALC(49,63), 17, A_NORMAL);
		GrayDrawChar(CALC(140,172), CALC(49,63), 18, A_NORMAL);
		
		loop1 = 1;
		
		Wait();
		
		do {
			
			key = 0;
			
			FastFilledRect_Invert_R(DPLANE, CALC(12,47) + loop1*16, CALC(48,62), CALC(24,59) + loop1*16, CALC(56,70));
			FastFilledRect_Invert_R(LPLANE, CALC(12,47) + loop1*16, CALC(48,62), CALC(24,59) + loop1*16, CALC(56,70));
			
			
		 	while (key != K_LEFT && key != K_RIGHT && key != K_ENTER) {
		 		key = KeyPressed();
		 		pokeIO(0x600005, 0b10111);
		 	}
		 	
		 	Delay(AUTO_REPEAT);
		 	
		 	FastFilledRect_Invert_R(DPLANE, CALC(12,47) + loop1*16, CALC(48,62), CALC(24,59) + loop1*16, CALC(56,70));
		 	FastFilledRect_Invert_R(LPLANE, CALC(12,47) + loop1*16, CALC(48,62), CALC(24,59) + loop1*16, CALC(56,70));
		 	
		 	if (key == K_LEFT) {
		 		loop1--;
		 	}
		 	else if (key == K_RIGHT) {
		 		loop1++;
		 	}
		 	
		 	if (loop1 == 0) {
		 		loop1 = TANKS;
		 	}
		 	else if (loop1 > TANKS) {
		 		loop1 = 1;
		 	}
		 	
	 	} while (key != K_ENTER);

	}
	
	else if (player[num].type == 2) {
		loop1 = random(TANKS) + 1;
	}
	
	player[num].tanknum = loop1;
	memcpy(player[num].tank, tanks[loop1 - 1], sizeof(tanks)/TANKS);
	
	Wait();
	
}

void Dispinf(unsigned int num) {
	
	char st_wind[8], st_angle[8], st_power[8], string[8];
	
	GrayDrawRect(0,0,CALC(159,239),CALC(16,20),COLOR_BLACK,RECT_FILLED);
	
	FontSetSys(CALC(F_4x6,F_6x8));
	GrayDrawStr2B(CALC(99,148),1,player[num].name,A_REVERSE,DPLANE,DPLANE);
	GrayDrawStr2B(1,1,(char*)"Angle",A_REVERSE,DPLANE,DPLANE);
	sprintf(st_angle,"%d",player[num].angle);
	GrayDrawStr2B(CALC(30,44),1,st_angle,A_REVERSE,DPLANE,DPLANE);
	GrayDrawStr2B(CALC(48,72),1,(char*)"Power",A_REVERSE,DPLANE,DPLANE);
	sprintf(st_power,"%d",player[num].power);
	GrayDrawStr2B(CALC(77,115),1,st_power,A_REVERSE,DPLANE,DPLANE);
	sprintf(st_wind,"%d",abs(game->wind));
	GrayDrawStr2B(CALC(144,215),1,st_wind,A_REVERSE,DPLANE,DPLANE);
	if (game->wind < 0) {
		GrayDrawStr2B(CALC(138,207),1,(char*)"\x15",A_REVERSE,DPLANE,DPLANE);
	}
	else if (game->wind > 0) {
		GrayDrawStr2B(CALC(153,229),1,(char*)"\x16",A_REVERSE,DPLANE,DPLANE);
	}
	GrayDrawRect(2, CALC(9,11), CALC(34,54), CALC(13,17), COLOR_WHITE, RECT_FILLED);
	if (player[num].health > 0) {
		GrayDrawRect(3, CALC(10,12), 3 + CALC(3,5)*player[num].health, CALC(12,16), COLOR_DARKGRAY, RECT_FILLED);
	}
	if (player[num].protect == PARACHUTE) {
		Sprite8_XOR_R(CALC(152,228), CALC(10,13), 4, parachute, DPLANE);
	}
	if (player[num].shield > 0) {
		Sprite8_XOR_R(CALC(133,199), CALC(8,11), 7, shield, DPLANE);
		sprintf(string, "%d", player[num].shield);
		GrayDrawStr2B(CALC(140,209), CALC(9,11), string, A_REVERSE, DPLANE, DPLANE);
	}
	GrayDrawStr2B(CALC(48,72),CALC(9,11),bombname[player[num].bomb[0]],A_REVERSE,DPLANE,DPLANE);
	
}

void Angle(unsigned int num, int key) {
	
	char st_angle[12];
	
	if (key == K_LEFT) {
		++player[num].angle;
	}
	else if (key == K_LEFT + K_2ND) {
		(player[num].angle) += 9;
	}
	
	else if (key == K_RIGHT) {
		--player[num].angle;
	}
	else if (key == K_RIGHT + K_2ND) {
		(player[num].angle) -= 9;
	}
	
	if (player[num].angle < 0) {
		player[num].angle = 0;
	}
	if (player[num].angle > 180) {
		player[num].angle = 180;
	}
	
	if (player[num].angle - player[num].angle_img >= 9 || player[num].angle - player[num].angle_img <= -9) {
		player[num].angle_img = player[num].angle;
		Tube(num);
	}
	
	sprintf(st_angle,"%d",player[num].angle);
	GrayDrawStrExt2B(CALC(30,44),1,CALC("      ","    "),A_REVERSE,CALC(F_4x6,F_6x8),DPLANE,DPLANE);
	GrayDrawStrExt2B(CALC(30,44),1,st_angle,A_REVERSE,CALC(F_4x6,F_6x8),DPLANE,DPLANE);
	
}

void Power(int *power, int key) {
	
	char st_power[12];
	
	if (key == K_UP) {
		++*power;
	}
	else if (key == K_UP + K_2ND) {
		(*power) += 10;
	}
	
	else if (key == K_DOWN) {
		--*power;
	}
	else if (key == K_DOWN + K_2ND) {
		(*power) -= 10;
	}
	
	if (*power < 1) {
		*power = 1;
	}
	if (*power > 100) {
		*power = 100;
	}
	sprintf(st_power,"%d",*power);
	GrayDrawStrExt2B(CALC(77,115),1,CALC("      ","    "),A_REVERSE,CALC(F_4x6,F_6x8),DPLANE,DPLANE);
	GrayDrawStrExt2B(CALC(77,115),1,st_power,A_REVERSE,CALC(F_4x6,F_6x8),DPLANE,DPLANE);
	
}

void DeleteMenuEntry(unsigned int num) {
	
	unsigned int loop1;
	
	for (loop1 = 0; loop1 < 10; loop1++) {
		Sprite8_AND_R(CALC(48,86) + 6*loop1, CALC(21,35) + 8*num, 8, font_mask, DPLANE);
	}
	
}

void DrawDoubleCursor(unsigned int option) {
	
	FontSetSys(CALC(F_6x8,F_8x10));
	GrayDrawChar(CALC(23,37), CALC(60+(option*12),86+(option*12)), 17, A_XOR);
  GrayDrawChar(CALC(136,184), CALC(60+(option*12),86+(option*12)), 18, A_XOR);
	
}

int MakeChoice(unsigned int x, unsigned int y, unsigned int dist, int options, unsigned int font, int pos) {
	
	int key = 0;
	//int pos = 0;
	unsigned int font_w[] = {4, 6, 8};
	
	FontSetSys(font);
	
	do {
		
		GrayDrawChar(x - 2 - font_w[font], y + (pos-1)*dist, 18, A_NORMAL);
		
		while (!(key = KeyPressed())) {
  		pokeIO(0x600005, 0b10111);
  	}
		
		Delay(AUTO_REPEAT);
		
		GrayDrawChar(x - 2 - font_w[font], y + (pos-1)*dist, 18, A_XOR);
		
		if (key == K_DOWN) {
			pos++;
		}
		else if (key == K_UP) {
			pos--;
		}
		
		if (pos == 0) {
			pos = options;
		}
		else if (pos > options) {
			pos = 1;
		}
		
		if (curfunc == GA_SETTINGS) {
			
			if (key == K_RIGHT) {
				return pos;
			}
			else if (key == K_LEFT) {
				return (-pos);
			}
			else if (key == K_ENTER) {
				return -10;
			}
			else if (key == K_F1) {
				return K_F1;
			}
			
		}
		
		
		//Delay(AUTO_REPEAT);
		
	} while (key != K_ENTER && key != K_ESC);
	
	if (key == K_ESC) {
		pos = -10;
	}
	
	return pos;
	
}


void DialogStatusLine(unsigned int mode) {
	
	GrayFastFillRect_R(LPLANE,DPLANE,CALC(6,41),CALC(84,95),CALC(154,199),CALC(90,101),COLOR_DARKGRAY);
	
	GrayDrawStrExt2B(0, CALC(85,96), statusmsg[mode], A_REVERSE | A_CENTERED, F_4x6, DPLANE, DPLANE);
	
}

//ti89 version: completely done